Attribute VB_Name = "modSubClass"
Option Explicit
'
Public Const GWL_USERDATA = (-21)
Public Const GWL_WNDPROC = -4
Public Const GWL_STYLE = (-16)
'
Public Const WS_CHILD = &H40000000
Public Const WS_VISIBLE = &H10000000
Public Const WS_DISABLED = &H8000000
'
Public Const WM_DESTROY = &H2
Public Const WM_SETFONT = &H30
Public Const WM_NOTIFY = &H4E
Public Const WM_CHAR = &H102
Public Const WM_RBUTTONUP = &H205
Public Const WM_LBUTTONDOWN = &H201
'
Public Const GDT_ERROR = -1&
Public Const GDT_VALID = 0&
'
Public Const DTN_FIRST As Long = -760
Public Const MCM_FIRST = &H1000&
Public Const DTM_FIRST = &H1000&
'
Private Const DTM_GETSYSTEMTIME = (DTM_FIRST + 1)
Private Const DTM_GETMONTHCAL = (DTM_FIRST + 8)
'
Private Const DTN_DATETIMECHANGE = (DTN_FIRST + 1) ' // the systemtime has changed
Private Const DTN_DROPDOWN = (DTN_FIRST + 6) '       // MonthCal has dropped down
Private Const DTN_CLOSEUP = (DTN_FIRST + 7) '        // MonthCal is popping up
' // set first day of week to iDay:
' // 0 = Monday, ..., 6 = Sunday // -1 = use locale
Private Const MCM_SETFIRSTDAYOFWEEK = (MCM_FIRST + 15)
Private Const MCM_GETFIRSTDAYOFWEEK = (MCM_FIRST + 16)
'
Private Const MCS_WEEKNUMBERS = &H4
Private Const MCS_NOTODAYCIRCLE = &H8
Private Const MCS_NOTODAY = &H10
'
Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
'
Public Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type
'
Public Type NMHDR
    hwndFrom As Long
    idfrom As Long
    code As Long
End Type
'
Public Type NMDATETIMECHANGE
    NMHDR As NMHDR
    dwFlags As Long
    st As SYSTEMTIME
End Type
'
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal uMgs As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function apiSetFocus Lib "user32" Alias "SetFocus" (ByVal hwnd As Long) As Long
Public Declare Function apiGetFocus Lib "user32" Alias "GetFocus" () As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Any) As Long
Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
'
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal wndrpcPrev As Long, ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function IsWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
'
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSrc As Any, ByVal ByteLen As Long)
'
Private Declare Sub OleTranslateColor Lib "oleaut32.dll" (ByVal ColorIn As Long, ByVal hPal As Long, ByRef RGBColorOut As Long)
'
'
' Use to track Multiple DatePicker controls and their subclassing
'
Public scCollection As New Collection
'
' This function is used to allow the user to right click
' on the background of the date-picker, and switch between
' displaying the dropdown button or the spin button
'
Public Function ToggleWinProc(ByVal hwnd As Long, ByVal uMsg As Long, _
                        ByVal wParam As Long, ByVal lParam As Long) As Long
'
    Dim mcObj As Object
'
    On Error Resume Next
    Set mcObj = scCollection.Item("U" & Hex(hwnd))
    If mcObj Is Nothing Then Exit Function
    On Error GoTo 0
'
    Select Case uMsg
    Case WM_RBUTTONUP
    
        mcObj.UpDown = Not mcObj.UpDown
    
    Case WM_LBUTTONDOWN
        
        If apiGetFocus <> mcObj.hwnd Then apiSetFocus mcObj.hwnd
    
    Case WM_CHAR
    
        If mcObj.hwnd > 0 Then
            ' Pass through keys after setting focus to the user control
            ' This handles tabs, shift-tabs, returns, etc.
            ' (if not already focused)
            If apiGetFocus <> hwnd Then
                apiSetFocus mcObj.hwnd
                SendKeys Chr$(wParam)
            End If
            
        End If
        Exit Function
    
    Case WM_DESTROY
        
        If mcObj.HWndUCProc <> 0 Then
            SetWindowLong hwnd, GWL_WNDPROC, CLng(mcObj.HWndUCProc)
        Else
            SetWindowLong hwnd, GWL_WNDPROC, 0&
            Exit Function
        End If
    
    End Select
    
    If mcObj.HWndUCProc <> 0 And CBool(IsWindow(hwnd)) Then
        ToggleWinProc = CallWindowProc(mcObj.HWndUCProc, hwnd, uMsg, wParam, ByVal lParam)
    End If
    
End Function
'
Public Function ChangeWinProc(ByVal hwnd As Long, ByVal uMsg As Long, _
                        ByVal wParam As Long, ByVal lParam As Long) As Long
'
    Dim mcNmHdr As NMHDR
    Dim mcNmDTC As NMDATETIMECHANGE
    Dim mcObj As Object
    Dim mlHwnd As Long
    Dim mlStyle As Long
    Dim mlRect As RECT
'
    On Error Resume Next
    Set mcObj = scCollection.Item("H" & Hex(hwnd))
    If mcObj Is Nothing Then Exit Function
    On Error GoTo 0
'
    Select Case uMsg
    Case WM_NOTIFY
        
        CopyMemory mcNmHdr, ByVal lParam, Len(mcNmHdr)
            
        Select Case mcNmHdr.code
        Case DTN_DROPDOWN
        
            If mcObj.HWndDP > 0 Then
                
                mlHwnd = SendMessage(mcObj.HWndDP, DTM_GETMONTHCAL, 0&, ByVal 0&)
        
                If mlHwnd > 0 Then
                    
                    ' Set the first day of week for the dropdown calendar
                    SendMessage mlHwnd, MCM_SETFIRSTDAYOFWEEK, _
                        0, ByVal FDOW(mcObj.FirstDayOfWeek)
                    
                    GetWindowRect mlHwnd, mlRect
                    
                    ' Get the current style bits
                    mlStyle = GetWindowLong(mlHwnd, GWL_STYLE)
                    
                    ' Show Week Numbers
                    mlStyle = mlStyle Or IIf(mcObj.ShowWeeks, MCS_WEEKNUMBERS, 0)
                    mlRect.Right = (mlRect.Right - mlRect.Left) * _
                                IIf(mcObj.ShowWeeks, 1.15, 1)
                    ' Hide today circle and today date
                    mlStyle = mlStyle Or IIf(Not mcObj.ShowToday, (MCS_NOTODAYCIRCLE Or MCS_NOTODAY), 0)
                    mlRect.Bottom = (mlRect.Bottom - mlRect.Top) * _
                                 IIf(Not mcObj.ShowToday, 0.92, 1)
                    
                    ' Set the modified style bits
                    SetWindowLong mlHwnd, GWL_STYLE, mlStyle

                    MoveWindow mlHwnd, mlRect.Left, mlRect.Top, _
                            mlRect.Right, mlRect.Bottom, True
                    
                    ' This doevents appears to be needed to handle
                    ' the case where focus is given to the control
                    ' and the dropdown is shown at the same time
                    DoEvents
                    
                    If apiGetFocus <> hwnd Then apiSetFocus hwnd
                    
                End If
                
            End If
        
        Case DTN_CLOSEUP
        
            If mcObj.HWndDP <> apiGetFocus Then apiSetFocus mcObj.HWndDP
        
        Case DTN_DATETIMECHANGE
            ' Whenever the datepicker date changes this
            ' message is processed.
            CopyMemory mcNmDTC, ByVal lParam, Len(mcNmDTC)
            ' if the flag = GDT_VALID, then save the date
            If mcNmDTC.dwFlags = GDT_VALID Then
                mcObj.HWndValue = GetDate(mcNmDTC.st)
            End If
        
        End Select
        
    Case WM_DESTROY
        
        If mcObj.HWndProc <> 0 Then
            SetWindowLong hwnd, GWL_WNDPROC, CLng(mcObj.HWndProc)
        Else
            SetWindowLong hwnd, GWL_WNDPROC, 0&
            Exit Function
        End If
    
    End Select
'
    If mcObj.HWndProc <> 0 And CBool(IsWindow(hwnd)) Then
        ChangeWinProc = CallWindowProc(mcObj.HWndProc, hwnd, uMsg, wParam, ByVal lParam)
    End If
'
End Function
'
Public Sub SetDate(ByVal New_Date As Date, st As SYSTEMTIME)
    If New_Date = 0 Then New_Date = Date
    With st
        .wDay = Day(New_Date)
        .wMonth = Month(New_Date)
        .wYear = Year(New_Date)
        .wHour = Hour(New_Date)
        .wMinute = Minute(New_Date)
        .wSecond = Second(New_Date)
    End With
End Sub
'
Public Function GetDate(st As SYSTEMTIME) As Date
    With st
        GetDate = DateSerial(.wYear, .wMonth, .wDay) + _
                  TimeSerial(.wHour, .wMinute, .wSecond)
    End With
End Function
'
Public Function OleColor(ByVal Color As OLE_COLOR) As OLE_COLOR
    If Color < 0 Then
        ' Translate the system color constant, to it's RGB value
        OleTranslateColor Color, 0, Color
    End If
    OleColor = Color
End Function
'
Public Function FDOW(ByVal iDate As VbDayOfWeek) As Long
    ' VBDayOfWeek specifies 'Use System' = 0, Sun=1, Mon=2, ...
    ' FDOW specifies 'Use System' = -1, Mon=0, Tue=1, ...
    Select Case iDate
    Case vbSunday
        FDOW = 6
    Case vbMonday To vbSaturday
        FDOW = iDate - 2
    Case Else
        FDOW = -1
    End Select
End Function
'
